searchNodes=[{"type":"task","title":"Mix.Tasks.Yacto","doc":"Prints Yacto tasks and their information. mix yacto","ref":"Mix.Tasks.Yacto.html"},{"type":"task","title":"Mix.Tasks.Yacto.Gen.Migration","doc":"","ref":"Mix.Tasks.Yacto.Gen.Migration.html"},{"type":"function","title":"Mix.Tasks.Yacto.Gen.Migration.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Yacto.Gen.Migration.html#run/1"},{"type":"task","title":"Mix.Tasks.Yacto.Migrate","doc":"","ref":"Mix.Tasks.Yacto.Migrate.html"},{"type":"function","title":"Mix.Tasks.Yacto.Migrate.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Yacto.Migrate.html#run/1"},{"type":"module","title":"Yacto","doc":"Yacto は、 Ecto で手が届きにくい部分をサポートするためのライブラリです。 大まかに以下の機能があります。 マイグレーションファイルの自動生成 別アプリケーションからのマイグレーションの利用 水平分割したデータベースへのマイグレーション 複数データベースを跨るトランザクション（XA トランザクション） マイグレーションファイルの自動生成 Yacto は、特にマイグレーション周りが Ecto と異なります。 Ecto はスキーマとマイグレーションを別で定義していましたが、Yacto は スキーマからマイグレーションファイルを自動的に出力します 。 具体的には、以下の様にスキーマを定義したとして、 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema , dbname : :player schema @auto_source do # sharding key field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] index :player_id , unique : true end end この状態で mix yacto.gen.migration を実行すると、以下の様なマイグレーションファイルが出力されます。 priv/migrations/Elixir.MyApp.Player/0000-player-create-2020_04_22_085825.exs : defmodule MyApp.Player.Migration0000 do use Ecto.Migration def change ( ) do create table ( &quot;myapp_player&quot; ) alter table ( &quot;myapp_player&quot; ) do add ( :hp , :integer , [ null : false , size : 64 ] ) add ( :player_id , :string , [ null : false ] ) end create index ( &quot;myapp_player&quot; , [ :player_id ] , [ name : &quot;player_id_index&quot; , unique : true ] ) end def __migration__ ( :structure ) do { MyApp.Player , % Yacto.Migration.Structure { fields : [ :id , :player_id , :hp ] , meta : %{ attrs : %{ hp : %{ null : false } , player_id : %{ null : false , size : 64 } } , indices : %{ { [ :player_id ] , [ unique : true ] } =&gt; true } } , source : &quot;myapp_player&quot; , types : %{ hp : :integer , id : :id , player_id : :string } } } , end def __migration__ ( :version ) do 0 end end あとは mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もうマイグレーションファイルを自分で記述する必要はありません。 更に、この状態で MyApp.Player スキーマに :mp フィールドを追加して mix yacto.gen.migration を実行すると、以下のマイグレーションファイルが生成されます。 lib/my_app/player.ex: defmodule MyApp.Player do ... schema @auto_source do ... # add a field field :mp , :integer , default : 0 , meta : [ null : false ] ... end end priv/migrations/Elixir.MyApp.Player/0001-player-change-2020_04_22_092258.exs : defmodule MyApp.Player.Migration0001 do use Ecto.Migration def change ( ) do alter table ( &quot;myapp_player&quot; ) do add ( :mp , :integer , [ null : false ] ) end end def __migration__ ( :structure ) do [ { MyApp.Player , % Yacto.Migration.Structure { fields : [ :id , :player_id , :hp , :mp ] , meta : %{ attrs : %{ hp : %{ null : false } , mp : %{ null : false } , player_id : %{ null : false , size : 64 } } , indices : %{ { [ :player_id ] , [ unique : true ] } =&gt; true } } , source : &quot;myapp_player&quot; , types : %{ hp : :integer , id : :id , mp : :integer , player_id : :string } } } , ] end def __migration__ ( :version ) do 1 end end このように、以前からの差分だけがマイグレーションファイルに出力されます。 mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もしマイグレーションファイルが１つもデータベースに適用されていなかったら、上記の２つのマイグレーションファイルが順番に適用されます。 別アプリケーションからのマイグレーションの利用 先程作った my_app アプリケーションを利用する other_app アプリケーションがあったとします。 my_app はデータベース利用しているので、 other_app 上で my_app のためのマイグレーションを行う必要があります。 Yacto を使えば、 config/config.exs を適切に書いた後、 other_app で以下のコマンドを実行するだけで my_app のマイグレーションができます。 mix yacto . migrate -- app my_app Ecto では、他のアプリケーションが必要としているマイグレーションを自分で書くか、各アプリケーションが指定したバラバラな方法でマイグレーションを行う必要がありました。 Yacto を使っているアプリケーションでは、全て同じ方法でマイグレーションができます。 水平分割したデータベースへのマイグレーション 例えば MyApp.Player スキーマを水平分割した場合、このスキーマのマイグレーションファイルを複数の Repo に適用する必要があります。 これは、設定ファイルに以下の様に書くだけで出来ます。 config/config.exs: config :yacto , :databases , %{ default : %{ module : Yacto.DB.Single , repo : MyApp.Repo.Default , } , player : %{ module : Yacto.DB.Shard , repos : [ MyApp.Repo.Player0 , MyApp.Repo.Player1 ] , } , } MyApp.Player に以下のコードがあったことを思い出して下さい。 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema , dbname : :player ... この :player が、 MyApp.Player が所属する Repo のグループ名です。 MyApp.Player は :player という Repo グループに所属しており、 :player Repo グループは設定ファイルから MyApp.Repo.Player0 と MyApp.Repo.Player1 の Repo に紐付いていることが分かります。 設定ファイルを書いたら、あとは mix yacto.migrate を実行するだけです。 MyApp.Player のマイグレーションファイルが MyApp.Repo.Player0 と MyApp.Repo.Player1 に適用されます。 水平分割したデータベースを利用する時には、 Yacto.DB.repo/2 を使って Repo を取得します。 repo = Yacto.DB . repo ( :player , shard_key : player_id ) MyApp.Player |&gt; repo . all ( ) 他のアプリケーションから利用する もちろん、この水平分割した my_app アプリケーションを other_app で利用することもできます。 other_app で以下の様に設定ファイル書いて、 config/config.exs: config :yacto , :databases , %{ default : %{ module : Yacto.DB.Single , repo : OtherApp.Repo.Default , } , player : %{ module : Yacto.DB.Shard , repos : [ OtherApp.Repo.Player0 , OtherApp.Repo.Player1 , OtherApp.Repo.Player2 ] , } , } mix yacto.migrate --app my_app を実行すると、 OtherApp.Repo.Player0 と OtherApp.Repo.Player1 と OtherApp.Repo.Player2 に MyApp.Player スキーマのマイグレーションファイルが適用されます。 複数データベースを跨るトランザクション（XA トランザクション） Yacto.transaction/2 を使うと、複数のデータベースを指定してトランザクションを発行できます。 # ２つ以上の Repo が指定されているので XA トランザクションを発行する Yacto . transaction ( [ :default , { :player , player_id1 } , { :player , player_id2 } ] , fn -&gt; default_repo = Yacto.DB . repo ( :default ) player1_repo = Yacto.DB . repo ( :player , player_id1 ) player2_repo = Yacto.DB . repo ( :player , player_id2 ) # ここら辺でデータベースを操作する ... # ここで全ての XA トランザクションがコミットされる end ) 以下の３つの Repo に対してトランザクションを行います。 :default の Repo MyApp.Repo.Default player_id1 でシャーディングされた Repo player_id2 でシャーディングされた Repo 後ろの２つは、シャードキーによっては同じ Repo になる可能性があるので、利用する Repo は２つか３つのどちらかです。 ２つ以上の Repo を利用してトランザクションを開始する場合、自動的に XA トランザクションになります。 XA トランザクションは確実に不整合が防げる訳ではありませんが、別々でトランザクションを発行するよりは防げます。 ただしこのライブラリでは XA RECOVER に残ったトランザクションを解決する仕組みを提供していないので、別途用意する必要があります。 Yacto のスキーマ Yacto のスキーマについて、まだ説明していない部分があるので、もう少し詳しく説明します。 最初に書いたように、Yacto のスキーマは以下の様に定義します。 defmodule MyApp.Player do use Yacto.Schema , dbname : :player schema @auto_source do field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] index :player_id , unique : true end end 基本的には Ecto.Schema と変わりません。 Yacto.Schema で生成したスキーマは、 Ecto.Schema で生成したスキーマと互換性があります。 ただしマイグレーションに関する設定が含まれるので、 Ecto.Schema よりもいくつか設定が増えています。 テーブル名の自動生成 @auto_source には、モジュール名から自動的に生成したテーブル名が定義されています。 大抵の場合、自動的に決まった名前で問題ないと思うので、常に @auto_source を使うので問題ないでしょう。 メタ情報 field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] field :height , :decimal , meta : [ precision : 10 , scale : 3 ] ここは Ecto.Schema の field/3 関数とほとんど同じですが、 :meta オプションがあるという点で異なります。 :meta オプションはマイグレーションに関する情報を入れる場所で、そのフィールドが null 可能かどうかや、文字列のサイズ等を指定します。 指定可能なオプションは以下の通りです。 :null : そのフィールドが null 可能かどうか（デフォルトでは true ） :size : 文字列のサイズ（ VARCHAR(255) の 255 に相当する部分）（デフォルトでは 255 ） :default : そのフィールドのデフォルト値（デフォルトでは各型の初期値か、 opts[:default] が存在している場合はその値が入る） :precision : field/3 に渡す型が :decimal の場合の最大桁数を指定する（デフォルト値は利用する DB の仕様に従う） :scale : field/3 に渡す型が :decimal の場合の小数部の桁数を指定する（デフォルト値は利用する DB の仕様に従う） :index : このフィールドでインデックスを張るかどうか（デフォルトでは false ） :type : マイグレーション時の型を指定する（デフォルトでは field/3 で指定した型） インデックス index :player_id , unique : true index/2 でインデックスを生成できます。 field/3 の :meta オプションの中でもインデックスを指定できますが、 index/2 を使うと複合インデックスやユニークインデックスも生成できます。 複合インデックスにするなら index [:player_id, :hp] のようにリストで指定します。 ユニークインデックスにするならオプションで unique: true を指定します。 外部キー制約 対応していません。 必要だと思ったのであれば、ぜひ実装して pull req 下さい。 便利関数 Yacto は、Repo に便利な関数を定義する Yacto.Repo.Helper を提供しています。 defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app use Yacto.Repo.Helper end これによって、以下の関数が定義されます。 def count(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで要素数を返します。 def find(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から取得します。 def delete_by(queryable, clauses, opts \\\\ []) def delete_by!(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から削除します。 delete_by!/3 は、削除した件数が 0 だった時に Ecto.NoResultsError 例外を投げます。 def find_for_update(queryable, clauses, opts \\\\ []) get_for_update(queryable, id, opts \\\\ []) get_for_update!(queryable, id, opts \\\\ []) get_by_for_update(queryable, clauses, opts \\\\ []) get_by_for_update!(queryable, clauses, opts \\\\ []) SELECT ... FOR UPDATE のクエリを使って要素を取得する関数です。 find_for_update/3 は find/3 のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_for_update/3 や get_by_for_update/3 関数は、 Ecto.Repo.get や Ecto.Repo.get_by のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_by_or_new(queryable, clauses, default_struct, opts \\\\ []) get_by_or_insert_for_update(queryable, clauses, default_struct_or_changeset, opts \\\\ []) get_by_or_new/4 は、まずレコードを取得してみて、あればそのレコードを、無ければデフォルト値 default_struct を返します。無かった場合でもデータベースへの挿入は行いません。 ロックを取らないので、この get_by_or_new/4 で得られた値を使ってデータベースへ挿入や更新をしてはいけません。 戻り値は {record, defaulted} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいはデフォルト値）が、2要素目にはデフォルト値を返したかどうかのフラグが設定されます。 get_by_or_insert_for_update/4 は、 get_by_or_new/4 の排他ロックを取るバージョンです。 まずレコードを取得してみて、あればそのレコードを、無ければ新規に default_struct_or_changeset を挿入して返します。この時、返されるレコードは排他ロックされます。 戻り値は {record, created} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいは挿入したデフォルト値）が、2要素目には新しく挿入したかどうかのフラグが設定されます。","ref":"Yacto.html"},{"type":"function","title":"Yacto.transaction/3","doc":"","ref":"Yacto.html#transaction/3"},{"type":"behaviour","title":"Yacto.DB","doc":"Yacto の repo を取得するためのモジュール 水平分割をしている場合、シャーディングキーによって利用する repo が変わるため、 直接 repo を利用するのではなく、 Yacto.repo/{2-3} を利用する必要がある。","ref":"Yacto.DB.html"},{"type":"function","title":"Yacto.DB.all_repos/1","doc":"","ref":"Yacto.DB.html#all_repos/1"},{"type":"function","title":"Yacto.DB.repo/2","doc":"","ref":"Yacto.DB.html#repo/2"},{"type":"callback","title":"Yacto.DB.repo/3","doc":"","ref":"Yacto.DB.html#c:repo/3"},{"type":"function","title":"Yacto.DB.repos/2","doc":"","ref":"Yacto.DB.html#repos/2"},{"type":"callback","title":"Yacto.DB.repos/3","doc":"","ref":"Yacto.DB.html#c:repos/3"},{"type":"module","title":"Yacto.DB.Shard","doc":"","ref":"Yacto.DB.Shard.html"},{"type":"module","title":"Yacto.DB.Single","doc":"","ref":"Yacto.DB.Single.html"},{"type":"module","title":"Yacto.Migration.File","doc":"","ref":"Yacto.Migration.File.html"},{"type":"function","title":"Yacto.Migration.File.check_migration_files/1","doc":"","ref":"Yacto.Migration.File.html#check_migration_files/1"},{"type":"function","title":"Yacto.Migration.File.check_migrations/1","doc":"","ref":"Yacto.Migration.File.html#check_migrations/1"},{"type":"function","title":"Yacto.Migration.File.get_latest_migration_file/2","doc":"","ref":"Yacto.Migration.File.html#get_latest_migration_file/2"},{"type":"function","title":"Yacto.Migration.File.list_migration_files/2","doc":"","ref":"Yacto.Migration.File.html#list_migration_files/2"},{"type":"function","title":"Yacto.Migration.File.list_migration_modules/1","doc":"","ref":"Yacto.Migration.File.html#list_migration_modules/1"},{"type":"function","title":"Yacto.Migration.File.load_migration_module/2","doc":"","ref":"Yacto.Migration.File.html#load_migration_module/2"},{"type":"function","title":"Yacto.Migration.File.new/5","doc":"","ref":"Yacto.Migration.File.html#new/5"},{"type":"function","title":"Yacto.Migration.File.save/3","doc":"","ref":"Yacto.Migration.File.html#save/3"},{"type":"module","title":"Yacto.Migration.GenMigration","doc":"","ref":"Yacto.Migration.GenMigration.html"},{"type":"function","title":"Yacto.Migration.GenMigration.generate/3","doc":"","ref":"Yacto.Migration.GenMigration.html#generate/3"},{"type":"function","title":"Yacto.Migration.GenMigration.generate_fields/4","doc":"","ref":"Yacto.Migration.GenMigration.html#generate_fields/4"},{"type":"function","title":"Yacto.Migration.GenMigration.generate_indices/3","doc":"","ref":"Yacto.Migration.GenMigration.html#generate_indices/3"},{"type":"module","title":"Yacto.Migration.Migrator","doc":"","ref":"Yacto.Migration.Migrator.html"},{"type":"function","title":"Yacto.Migration.Migrator.migrate/6","doc":"","ref":"Yacto.Migration.Migrator.html#migrate/6"},{"type":"function","title":"Yacto.Migration.Migrator.migrated_versions/3","doc":"","ref":"Yacto.Migration.Migrator.html#migrated_versions/3"},{"type":"function","title":"Yacto.Migration.Migrator.up/6","doc":"","ref":"Yacto.Migration.Migrator.html#up/6"},{"type":"module","title":"Yacto.Migration.SchemaMigration","doc":"","ref":"Yacto.Migration.SchemaMigration.html"},{"type":"function","title":"Yacto.Migration.SchemaMigration.down/4","doc":"","ref":"Yacto.Migration.SchemaMigration.html#down/4"},{"type":"function","title":"Yacto.Migration.SchemaMigration.drop/1","doc":"","ref":"Yacto.Migration.SchemaMigration.html#drop/1"},{"type":"function","title":"Yacto.Migration.SchemaMigration.drop_and_create/1","doc":"","ref":"Yacto.Migration.SchemaMigration.html#drop_and_create/1"},{"type":"function","title":"Yacto.Migration.SchemaMigration.ensure_schema_migrations_table!/1","doc":"","ref":"Yacto.Migration.SchemaMigration.html#ensure_schema_migrations_table!/1"},{"type":"function","title":"Yacto.Migration.SchemaMigration.migrated_versions/3","doc":"","ref":"Yacto.Migration.SchemaMigration.html#migrated_versions/3"},{"type":"function","title":"Yacto.Migration.SchemaMigration.up/4","doc":"","ref":"Yacto.Migration.SchemaMigration.html#up/4"},{"type":"module","title":"Yacto.Migration.Structure","doc":"","ref":"Yacto.Migration.Structure.html"},{"type":"function","title":"Yacto.Migration.Structure.diff/2","doc":"","ref":"Yacto.Migration.Structure.html#diff/2"},{"type":"function","title":"Yacto.Migration.Structure.from_schema/1","doc":"","ref":"Yacto.Migration.Structure.html#from_schema/1"},{"type":"function","title":"Yacto.Migration.Structure.to_string/1","doc":"","ref":"Yacto.Migration.Structure.html#to_string/1"},{"type":"module","title":"Yacto.Migration.Util","doc":"","ref":"Yacto.Migration.Util.html"},{"type":"function","title":"Yacto.Migration.Util.allow_migrate?/3","doc":"","ref":"Yacto.Migration.Util.html#allow_migrate?/3"},{"type":"function","title":"Yacto.Migration.Util.get_all_schema/2","doc":"","ref":"Yacto.Migration.Util.html#get_all_schema/2"},{"type":"function","title":"Yacto.Migration.Util.get_migration_dir/1","doc":"","ref":"Yacto.Migration.Util.html#get_migration_dir/1"},{"type":"function","title":"Yacto.Migration.Util.get_migration_dir_for_gen/0","doc":"","ref":"Yacto.Migration.Util.html#get_migration_dir_for_gen/0"},{"type":"function","title":"Yacto.Migration.Util.is_migration_module?/1","doc":"","ref":"Yacto.Migration.Util.html#is_migration_module?/1"},{"type":"function","title":"Yacto.Migration.Util.is_schema_module?/1","doc":"","ref":"Yacto.Migration.Util.html#is_schema_module?/1"},{"type":"function","title":"Yacto.Migration.Util.need_gen_migration?/1","doc":"","ref":"Yacto.Migration.Util.html#need_gen_migration?/1"},{"type":"module","title":"Yacto.Query","doc":"クエリに関する便利関数を提供するモジュール","ref":"Yacto.Query.html"},{"type":"function","title":"Yacto.Query.for_update/1","doc":"SELECT ... FOR UPDATE のクエリを発行する","ref":"Yacto.Query.html#for_update/1"},{"type":"module","title":"Yacto.Repo.Helper","doc":"repo のためのヘルパ関数 defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app use Yacto.Repo.Helper end person = MyApp.Repo . get_or_insert_for_update ( Person , [ name : &quot;foo&quot; ] , % Person { name : &quot;foo&quot; , value : 10 } ) # これで person は排他ロックになる changeset = Person . changeset ( person , [ value : person . value + 5 ] ) _person = MyApp.Repo . update! ( changeset )","ref":"Yacto.Repo.Helper.html"},{"type":"behaviour","title":"Yacto.Schema","doc":"Yacto 用のスキーマ 以下のように利用する。 defmodule MyApp.Schema.Item do use Yacto.Schema , dbname : :default schema @auto_source do field :name , :string , meta : [ null : false , size : 16 , index : true ] end end defmodule MyApp.Schema.Player do use Yacto.Schema , dbname : :player schema @auto_source do field :name , :string , meta : [ null : false , size : 16 , index : true ] end end","ref":"Yacto.Schema.html"},{"type":"callback","title":"Yacto.Schema.dbname/0","doc":"","ref":"Yacto.Schema.html#c:dbname/0"},{"type":"macro","title":"Yacto.Schema.field/3","doc":"","ref":"Yacto.Schema.html#field/3"},{"type":"macro","title":"Yacto.Schema.index/2","doc":"","ref":"Yacto.Schema.html#index/2"},{"type":"macro","title":"Yacto.Schema.schema/2","doc":"","ref":"Yacto.Schema.html#schema/2"},{"type":"macro","title":"Yacto.Schema.timestamps/1","doc":"","ref":"Yacto.Schema.html#timestamps/1"},{"type":"module","title":"Yacto.XA","doc":"XA トランザクションを行うためのモジュール","ref":"Yacto.XA.html"},{"type":"function","title":"Yacto.XA.in_xa_transaction?/1","doc":"","ref":"Yacto.XA.html#in_xa_transaction?/1"},{"type":"function","title":"Yacto.XA.rollback/2","doc":"","ref":"Yacto.XA.html#rollback/2"},{"type":"function","title":"Yacto.XA.transaction/3","doc":"","ref":"Yacto.XA.html#transaction/3"},{"type":"function","title":"Yacto.XA.with_xa/3","doc":"","ref":"Yacto.XA.html#with_xa/3"},{"type":"module","title":"Yacto.XA.RepoState","doc":"","ref":"Yacto.XA.RepoState.html"},{"type":"exception","title":"Yacto.XA.RollbackError","doc":"","ref":"Yacto.XA.RollbackError.html"},{"type":"extras","title":"変更履歴","doc":"UPDATE 下位互換がある変更 ADD 下位互換がある追加 CHANGE 下位互換のない変更 FIX バグ修正","ref":"changelog.html"},{"type":"extras","title":"変更履歴 - develop","doc":"","ref":"changelog.html#develop"},{"type":"extras","title":"変更履歴 - 2.0.4 (2023-06-22)","doc":"[UPDATE] Elixir 1.15 に対応 [UPDATE] 依存ライブラリを更新 ecto_sql: 3.8.3 → 3.10.2 memoize: 1.4.1 → 1.4.2 ex_doc: 0.28.5 → 0.29.4 myxql: 0.6.2 → 0.6.3","ref":"changelog.html#2-0-4-2023-06-22"},{"type":"extras","title":"変更履歴 - 2.0.3 (2022-09-04)","doc":"[UPDATE] Elixir 1.14 に対応 [UPDATE] 依存ライブラリを更新 ecto_sql: 3.7.2 → 3.8.3 myxql: 0.6.1 → 0.6.2 ex_doc: 0.28.2 → 0.28.5 memoize: 1.4.0 → 1.4.1","ref":"changelog.html#2-0-3-2022-09-04"},{"type":"extras","title":"変更履歴 - 2.0.2 (2022-03-15)","doc":"[UPDATE] 依存ライブラリを更新 ecto_sql: 3.6.0 → 3.7.2 myxql: 0.5.1 → 0.6.1 ex_doc: 0.25.0 → 0.28.2 memoize: 1.3.3 → 1.4.0 power_assert: 0.2.1 → 0.3.0","ref":"changelog.html#2-0-2-2022-03-15"},{"type":"extras","title":"変更履歴 - 2.0.1 (2021-04-04)","doc":"[UPDATE] 依存ライブラリを更新 ecto_sql: 3.5.0 → 3.6.0 myxql: 0.4.3 → 0.5.1 ex_doc: 0.22.6 → 0.24.1 memoize: 1.3.1 → 1.3.3 power_assert: 0.2.0 → 0.2.1","ref":"changelog.html#2-0-1-2021-04-04"},{"type":"extras","title":"変更履歴 - 2.0.0 (2020-10-07)","doc":"下位互換のない変更 [CHANGE] マイグレーションファイルをモデル毎に生成する 今まで生成した全てのマイグレーションファイルは利用できなくなります。 新しく生成したマイグレーションファイルで mix yacto.migrate --fake を実行して新しくマイグレーションスキーマを設定する必要があります。 [CHANGE] Yacto.Schema で定義していたデフォルトの @primary_key を削除した [CHANGE] @auto_source から生成するテーブル名のルールを変更した 例えば App.Model.FooBar の場合、1.x では app_model_foo_bar になっていたが、2.x では app_model_foobar となる [CHANGE] Yacto.DB の引数にキーワードリストを取れるようにして、データベースの設定を動的に渡せるようにした Yacto.DB.repo(:player, &quot;key&quot;) と書いていたのを Yacto.DB.repo(:player, shard_key: &quot;key&quot;) と書く必要がある [CHANGE] :table_name_converter は不完全な機能だったので削除した [CHANGE] Yacto.Schema.Single と Yacto.Schema.Shard を削除した データベースの設定を動的に渡せるようになり、 Yacto.Schema.Single と Yacto.Schema.Shard のチェック機構が使えなくなるため。 [CHANGE] mix yacto.migrate で --repo を指定しなかった場合に利用するリポジトリ一覧を :ecto_repos から取得するようにした 下位互換がある追加 [ADD] スキーマの定義時にマイグレーションファイルを生成するかどうかを選択できるようにした（Thanks @mori5321 !） [ADD] field/3 のマイグレーション用メタ情報に :precision と :scale を追加 [ADD] モデルを削除した時に drop table する機能を実装 [ADD] マイグレーションファイルを検証する機能を実装 複数のブランチからマージした場合に矛盾が起きる可能性があったので、それを検出してエラーにする [ADD] Yacto.transaction/3 に、XA を行わない :noxa オプションを追加した 下位互換がある変更 [UPDATE] Ecto 3.5 への対応 MySQL Adapter をやめて MyXQL Adapter を使うようにした 新しいバージョンの Ecto.Migration.Runner に追従 [UPDATE] Elixir 1.11 への対応 [UPDATE] 全体的に日本語でやることにした バグ修正 [FIX] インデックスの付いたフィールドを削除するとマイグレーションに失敗する問題を修正した (Thanks @h1u2i3 !) [FIX] DB の新規作成時に、カラムの並びが定義順になるようにした [FIX] :index_name_max_length 設定がある場合、長いインデックス名を削るようにした [FIX] get_for_update/3 を修正した [FIX] テスト周りのリファクタリング","ref":"changelog.html#2-0-0-2020-10-07"},{"type":"extras","title":"変更履歴 - 1.2.6","doc":"Implement table name converter","ref":"changelog.html#1-2-6"},{"type":"extras","title":"変更履歴 - 1.2.5","doc":"Use asdf Fix migration error when using custom Ecto.Type with default value","ref":"changelog.html#1-2-5"},{"type":"extras","title":"変更履歴 - 1.2.4","doc":"Customize a hashing function for sharding databases","ref":"changelog.html#1-2-4"},{"type":"extras","title":"変更履歴 - 1.2.3","doc":"Fix a migration error is occured when using :source in field","ref":"changelog.html#1-2-3"},{"type":"extras","title":"変更履歴 - 1.2.2","doc":"timestamps/1 can be had :meta","ref":"changelog.html#1-2-2"},{"type":"extras","title":"変更履歴 - 1.2.1","doc":"Fix an issue where using autogenerate: {m, f, a} in @primary_key definition causes an error Implement @primary_key_meta that specify a primary key meta info for migration","ref":"changelog.html#1-2-1"},{"type":"extras","title":"変更履歴 - 1.2.0","doc":"Implement Yacto.XA.rollback/2","ref":"changelog.html#1-2-0"},{"type":"extras","title":"変更履歴 - 1.1.3","doc":"Update dependencies","ref":"changelog.html#1-1-3"},{"type":"extras","title":"変更履歴 - 1.1.2","doc":"In Yacto.Schema.field/3 , if opts[:default] is specified, set the value to meta[:default]","ref":"changelog.html#1-1-2"},{"type":"extras","title":"変更履歴 - 1.1.1","doc":"Rename get_or_new/4 to get_by_or_new/4 and get_or_insert_for_update/4 to get_by_or_insert_for_update/4","ref":"changelog.html#1-1-1"},{"type":"extras","title":"変更履歴 - 1.1.0","doc":"Add Yacto.Schema.Single and Yacto.Schema.Shard modules. These define repo/{0-1} after use Yacto.Schema . Add Yacto.Repo.Helper to provide convenient functions.","ref":"changelog.html#1-1-0"},{"type":"extras","title":"変更履歴 - 1.0.7","doc":"Apply elixir formatter Fix warnings Update dependencies","ref":"changelog.html#1-0-7"},{"type":"extras","title":"変更履歴 - 1.0.6","doc":"[Bug] Fix a migration type name includes with spaces.","ref":"changelog.html#1-0-6"},{"type":"extras","title":"変更履歴 - 1.0.5","doc":"Shorten index name for too long name error. Use specified migration type if :type defined in meta Remove illegal character in filename for Windows","ref":"changelog.html#1-0-5"},{"type":"extras","title":"ライセンス","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html"},{"type":"extras","title":"概要","doc":"Yacto は、 Ecto で手が届きにくい部分をサポートするためのライブラリです。 大まかに以下の機能があります。 マイグレーションファイルの自動生成 別アプリケーションからのマイグレーションの利用 水平分割したデータベースへのマイグレーション 複数データベースを跨るトランザクション（XA トランザクション）","ref":"readme.html"},{"type":"extras","title":"概要 - マイグレーションファイルの自動生成","doc":"Yacto は、特にマイグレーション周りが Ecto と異なります。 Ecto はスキーマとマイグレーションを別で定義していましたが、Yacto は スキーマからマイグレーションファイルを自動的に出力します 。 具体的には、以下の様にスキーマを定義したとして、 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema , dbname : :player schema @auto_source do # sharding key field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] index :player_id , unique : true end end この状態で mix yacto.gen.migration を実行すると、以下の様なマイグレーションファイルが出力されます。 priv/migrations/Elixir.MyApp.Player/0000-player-create-2020_04_22_085825.exs : defmodule MyApp.Player.Migration0000 do use Ecto.Migration def change ( ) do create table ( &quot;myapp_player&quot; ) alter table ( &quot;myapp_player&quot; ) do add ( :hp , :integer , [ null : false , size : 64 ] ) add ( :player_id , :string , [ null : false ] ) end create index ( &quot;myapp_player&quot; , [ :player_id ] , [ name : &quot;player_id_index&quot; , unique : true ] ) end def __migration__ ( :structure ) do { MyApp.Player , % Yacto.Migration.Structure { fields : [ :id , :player_id , :hp ] , meta : %{ attrs : %{ hp : %{ null : false } , player_id : %{ null : false , size : 64 } } , indices : %{ { [ :player_id ] , [ unique : true ] } =&gt; true } } , source : &quot;myapp_player&quot; , types : %{ hp : :integer , id : :id , player_id : :string } } } , end def __migration__ ( :version ) do 0 end end あとは mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もうマイグレーションファイルを自分で記述する必要はありません。 更に、この状態で MyApp.Player スキーマに :mp フィールドを追加して mix yacto.gen.migration を実行すると、以下のマイグレーションファイルが生成されます。 lib/my_app/player.ex: defmodule MyApp.Player do ... schema @auto_source do ... # add a field field :mp , :integer , default : 0 , meta : [ null : false ] ... end end priv/migrations/Elixir.MyApp.Player/0001-player-change-2020_04_22_092258.exs : defmodule MyApp.Player.Migration0001 do use Ecto.Migration def change ( ) do alter table ( &quot;myapp_player&quot; ) do add ( :mp , :integer , [ null : false ] ) end end def __migration__ ( :structure ) do [ { MyApp.Player , % Yacto.Migration.Structure { fields : [ :id , :player_id , :hp , :mp ] , meta : %{ attrs : %{ hp : %{ null : false } , mp : %{ null : false } , player_id : %{ null : false , size : 64 } } , indices : %{ { [ :player_id ] , [ unique : true ] } =&gt; true } } , source : &quot;myapp_player&quot; , types : %{ hp : :integer , id : :id , mp : :integer , player_id : :string } } } , ] end def __migration__ ( :version ) do 1 end end このように、以前からの差分だけがマイグレーションファイルに出力されます。 mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もしマイグレーションファイルが１つもデータベースに適用されていなかったら、上記の２つのマイグレーションファイルが順番に適用されます。 別アプリケーションからのマイグレーションの利用 先程作った my_app アプリケーションを利用する other_app アプリケーションがあったとします。 my_app はデータベース利用しているので、 other_app 上で my_app のためのマイグレーションを行う必要があります。 Yacto を使えば、 config/config.exs を適切に書いた後、 other_app で以下のコマンドを実行するだけで my_app のマイグレーションができます。 mix yacto . migrate -- app my_app Ecto では、他のアプリケーションが必要としているマイグレーションを自分で書くか、各アプリケーションが指定したバラバラな方法でマイグレーションを行う必要がありました。 Yacto を使っているアプリケーションでは、全て同じ方法でマイグレーションができます。 水平分割したデータベースへのマイグレーション 例えば MyApp.Player スキーマを水平分割した場合、このスキーマのマイグレーションファイルを複数の Repo に適用する必要があります。 これは、設定ファイルに以下の様に書くだけで出来ます。 config/config.exs: config :yacto , :databases , %{ default : %{ module : Yacto.DB.Single , repo : MyApp.Repo.Default , } , player : %{ module : Yacto.DB.Shard , repos : [ MyApp.Repo.Player0 , MyApp.Repo.Player1 ] , } , } MyApp.Player に以下のコードがあったことを思い出して下さい。 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema , dbname : :player ... この :player が、 MyApp.Player が所属する Repo のグループ名です。 MyApp.Player は :player という Repo グループに所属しており、 :player Repo グループは設定ファイルから MyApp.Repo.Player0 と MyApp.Repo.Player1 の Repo に紐付いていることが分かります。 設定ファイルを書いたら、あとは mix yacto.migrate を実行するだけです。 MyApp.Player のマイグレーションファイルが MyApp.Repo.Player0 と MyApp.Repo.Player1 に適用されます。 水平分割したデータベースを利用する時には、 Yacto.DB.repo/2 を使って Repo を取得します。 repo = Yacto.DB . repo ( :player , shard_key : player_id ) MyApp.Player |&gt; repo . all ( ) 他のアプリケーションから利用する もちろん、この水平分割した my_app アプリケーションを other_app で利用することもできます。 other_app で以下の様に設定ファイル書いて、 config/config.exs: config :yacto , :databases , %{ default : %{ module : Yacto.DB.Single , repo : OtherApp.Repo.Default , } , player : %{ module : Yacto.DB.Shard , repos : [ OtherApp.Repo.Player0 , OtherApp.Repo.Player1 , OtherApp.Repo.Player2 ] , } , } mix yacto.migrate --app my_app を実行すると、 OtherApp.Repo.Player0 と OtherApp.Repo.Player1 と OtherApp.Repo.Player2 に MyApp.Player スキーマのマイグレーションファイルが適用されます。 複数データベースを跨るトランザクション（XA トランザクション） Yacto.transaction/2 を使うと、複数のデータベースを指定してトランザクションを発行できます。 # ２つ以上の Repo が指定されているので XA トランザクションを発行する Yacto . transaction ( [ :default , { :player , player_id1 } , { :player , player_id2 } ] , fn -&gt; default_repo = Yacto.DB . repo ( :default ) player1_repo = Yacto.DB . repo ( :player , player_id1 ) player2_repo = Yacto.DB . repo ( :player , player_id2 ) # ここら辺でデータベースを操作する ... # ここで全ての XA トランザクションがコミットされる end ) 以下の３つの Repo に対してトランザクションを行います。 :default の Repo MyApp.Repo.Default player_id1 でシャーディングされた Repo player_id2 でシャーディングされた Repo 後ろの２つは、シャードキーによっては同じ Repo になる可能性があるので、利用する Repo は２つか３つのどちらかです。 ２つ以上の Repo を利用してトランザクションを開始する場合、自動的に XA トランザクションになります。 XA トランザクションは確実に不整合が防げる訳ではありませんが、別々でトランザクションを発行するよりは防げます。 ただしこのライブラリでは XA RECOVER に残ったトランザクションを解決する仕組みを提供していないので、別途用意する必要があります。","ref":"readme.html#%E3%83%9E%E3%82%A4%E3%82%B0%E3%83%AC%E3%83%BC%E3%82%B7%E3%83%A7%E3%83%B3%E3%83%95%E3%82%A1%E3%82%A4%E3%83%AB%E3%81%AE%E8%87%AA%E5%8B%95%E7%94%9F%E6%88%90"},{"type":"extras","title":"概要 - Yacto のスキーマ","doc":"Yacto のスキーマについて、まだ説明していない部分があるので、もう少し詳しく説明します。 最初に書いたように、Yacto のスキーマは以下の様に定義します。 defmodule MyApp.Player do use Yacto.Schema , dbname : :player schema @auto_source do field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] index :player_id , unique : true end end 基本的には Ecto.Schema と変わりません。 Yacto.Schema で生成したスキーマは、 Ecto.Schema で生成したスキーマと互換性があります。 ただしマイグレーションに関する設定が含まれるので、 Ecto.Schema よりもいくつか設定が増えています。 テーブル名の自動生成 @auto_source には、モジュール名から自動的に生成したテーブル名が定義されています。 大抵の場合、自動的に決まった名前で問題ないと思うので、常に @auto_source を使うので問題ないでしょう。 メタ情報 field :player_id , :string , meta : [ null : false , size : 64 ] field :hp , :integer , default : 0 , meta : [ null : false ] field :height , :decimal , meta : [ precision : 10 , scale : 3 ] ここは Ecto.Schema の field/3 関数とほとんど同じですが、 :meta オプションがあるという点で異なります。 :meta オプションはマイグレーションに関する情報を入れる場所で、そのフィールドが null 可能かどうかや、文字列のサイズ等を指定します。 指定可能なオプションは以下の通りです。 :null : そのフィールドが null 可能かどうか（デフォルトでは true ） :size : 文字列のサイズ（ VARCHAR(255) の 255 に相当する部分）（デフォルトでは 255 ） :default : そのフィールドのデフォルト値（デフォルトでは各型の初期値か、 opts[:default] が存在している場合はその値が入る） :precision : field/3 に渡す型が :decimal の場合の最大桁数を指定する（デフォルト値は利用する DB の仕様に従う） :scale : field/3 に渡す型が :decimal の場合の小数部の桁数を指定する（デフォルト値は利用する DB の仕様に従う） :index : このフィールドでインデックスを張るかどうか（デフォルトでは false ） :type : マイグレーション時の型を指定する（デフォルトでは field/3 で指定した型） インデックス index :player_id , unique : true index/2 でインデックスを生成できます。 field/3 の :meta オプションの中でもインデックスを指定できますが、 index/2 を使うと複合インデックスやユニークインデックスも生成できます。 複合インデックスにするなら index [:player_id, :hp] のようにリストで指定します。 ユニークインデックスにするならオプションで unique: true を指定します。 外部キー制約 対応していません。 必要だと思ったのであれば、ぜひ実装して pull req 下さい。","ref":"readme.html#yacto-%E3%81%AE%E3%82%B9%E3%82%AD%E3%83%BC%E3%83%9E"},{"type":"extras","title":"概要 - 便利関数","doc":"Yacto は、Repo に便利な関数を定義する Yacto.Repo.Helper を提供しています。 defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app use Yacto.Repo.Helper end これによって、以下の関数が定義されます。 def count(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで要素数を返します。 def find(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から取得します。 def delete_by(queryable, clauses, opts \\\\ []) def delete_by!(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から削除します。 delete_by!/3 は、削除した件数が 0 だった時に Ecto.NoResultsError 例外を投げます。 def find_for_update(queryable, clauses, opts \\\\ []) get_for_update(queryable, id, opts \\\\ []) get_for_update!(queryable, id, opts \\\\ []) get_by_for_update(queryable, clauses, opts \\\\ []) get_by_for_update!(queryable, clauses, opts \\\\ []) SELECT ... FOR UPDATE のクエリを使って要素を取得する関数です。 find_for_update/3 は find/3 のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_for_update/3 や get_by_for_update/3 関数は、 Ecto.Repo.get や Ecto.Repo.get_by のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_by_or_new(queryable, clauses, default_struct, opts \\\\ []) get_by_or_insert_for_update(queryable, clauses, default_struct_or_changeset, opts \\\\ []) get_by_or_new/4 は、まずレコードを取得してみて、あればそのレコードを、無ければデフォルト値 default_struct を返します。無かった場合でもデータベースへの挿入は行いません。 ロックを取らないので、この get_by_or_new/4 で得られた値を使ってデータベースへ挿入や更新をしてはいけません。 戻り値は {record, defaulted} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいはデフォルト値）が、2要素目にはデフォルト値を返したかどうかのフラグが設定されます。 get_by_or_insert_for_update/4 は、 get_by_or_new/4 の排他ロックを取るバージョンです。 まずレコードを取得してみて、あればそのレコードを、無ければ新規に default_struct_or_changeset を挿入して返します。この時、返されるレコードは排他ロックされます。 戻り値は {record, created} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいは挿入したデフォルト値）が、2要素目には新しく挿入したかどうかのフラグが設定されます。","ref":"readme.html#%E4%BE%BF%E5%88%A9%E9%96%A2%E6%95%B0"},{"type":"extras","title":"概要 - Copyright and License","doc":"Apache License 2.0 Copyright 2017 gumi Inc . Licensed under the Apache License , Version 2.0 ( the &quot;License&quot; ) ; you may not use this file except in compliance with the License . You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing , software distributed under the License is distributed on an &quot;AS IS&quot; BASIS , WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND , either express or implied . See the License for the specific language governing permissions and limitations under the License .","ref":"readme.html#copyright-and-license"}]